import sys
import math
from sf_cost import *
from fbf3_cost import *
from df_cost import *
from t3d_cost import *
from t5d_cost import *
from dln_cost import *
from ft3_cost import *
from lh2_cost import *
from lh_hc_cost import *
from hc_cost import *
from cost_model import *

def sf_generate():
	sf_a_2q = open('../SC_2014/results/temp/sf_a-2q.txt','w')

	df_full_p = open('../SC_2014/results/temp/df_full_p.txt','w')
	df_k_N = open('../SC_2014/results/temp/df_k_N.txt','w')

	fbf3_k = open('../SC_2014/results/temp/fbf3_k_relaxed.txt','w')
	ft3_k = open('../SC_2014/results/temp/ft3_k.txt','w')
	dln_k = open('../SC_2014/results/temp/dln_k.txt','w')

	fbf3_N = open('../SC_2014/results/temp/fbf3_N.txt','w')
	ft3_N = open('../SC_2014/results/temp/ft3_N.txt','w')
	dln_N = open('../SC_2014/results/temp/dln_N.txt','w')

	t3d = open('../SC_2014/results/temp/t3d.txt','w')
	t5d = open('../SC_2014/results/temp/t5d.txt','w')
	lh2 = open('../SC_2014/results/temp/lh2.txt','w')
	lh_hc = open('../SC_2014/results/temp/lh_hc.txt','w')
	hc = open('../SC_2014/results/temp/hc.txt','w')


	
	sf_a_2q_power = open('../SC_2014/results/temp/sf_a-2q_power.txt','w')
	fbf3_power = open('../SC_2014/results/temp/fbf3_power.txt','w')
	df_power = open('../SC_2014/results/temp/df_power.txt','w')
	t3d_power = open('../SC_2014/results/temp/t3d_power.txt','w')
	t5d_power = open('../SC_2014/results/temp/t5d_power.txt','w')
	ft3_power = open('../SC_2014/results/temp/ft3_power.txt','w')
	lh2_power = open('../SC_2014/results/temp/lh2_power.txt','w')
	lh_hc_power = open('../SC_2014/results/temp/lh_hc_power.txt','w')
	hc_power = open('../SC_2014/results/temp/hc_power.txt','w')
	dln_power = open('../SC_2014/results/temp/dln_power.txt','w')

	sf_a_2q_routers = open('../SC_2014/results/temp/sf_a-2q_routers.txt','w')
	fbf3_routers = open('../SC_2014/results/temp/fbf3_routers.txt','w')
	df_routers = open('../SC_2014/results/temp/df_routers.txt','w')
	t3d_routers = open('../SC_2014/results/temp/t3d_routers.txt','w')
	t5d_routers = open('../SC_2014/results/temp/t5d_routers.txt','w')
	ft3_routers = open('../SC_2014/results/temp/ft3_routers.txt','w')
	lh2_routers = open('../SC_2014/results/temp/lh2_routers.txt','w')
	lh_hc_routers = open('../SC_2014/results/temp/lh_hc_routers.txt','w')
	hc_routers = open('../SC_2014/results/temp/hc_routers.txt','w')
	dln_routers = open('../SC_2014/results/temp/dln_routers.txt','w')
	
  
######################## fixed concentration - for a balanced DF

	ps = [2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15]

	for i in range(0, len(ps)):
		p = ps[i]
		#DF costs
		
		[df_final_cost,df_final_power,routers,endpoints] = df_cost_conc_fully_balanced(p)

		if(df_final_cost > 0):
			df_full_p.write(str(endpoints) + ' ' + str(int(df_final_cost)) + '\n')
		
		if(df_final_power > 0):
			df_power.write(str(endpoints) + ' ' + str(int(df_final_power)) + '\n')
	
		if(routers > 0):
			df_routers.write(str(endpoints) + ' ' + str(int(routers)) + '\n')

	print(">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>")

######################## fixed radix

####################### FT3

	ks = [5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51,52,53,54,55,56,57,58,59,60]

	for i in range(0,len(ks)):
		#FT-3 costs
		k = ks[i]
			
		[ft3_final_cost,ft3_final_power,routers,endpoints] = ft3_cost_radix(k)

		if(ft3_final_cost > 0):
			ft3_k.write(str(endpoints) + ' ' + str(int(ft3_final_cost)) + '\n')

		if(ft3_final_power > 0):
			ft3_power.write(str(endpoints) + ' ' + str(int(ft3_final_power)) + '\n')

		if(routers > 0):
			ft3_routers.write(str(endpoints) + ' ' + str(int(routers)) + '\n')

	print(">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>")
	
	#karys = [5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20]

	'''

	for i in range(0,len(ks)):
		#FBF costs
		#kary = karys[i]
		k = ks[i]

		[fbf3_final_cost,fbf3_final_power,routers,endpoints] = fbf3_cost_radix_relaxed(k)

		if(fbf3_final_cost > 0):
			fbf3_k.write(str(endpoints) + ' ' + str(int(fbf3_final_cost)) + '\n')

		if(fbf3_final_power > 0):
			fbf3_power.write(str(endpoints) + ' ' + str(int(fbf3_final_power)) + '\n')

		if(routers > 0):
			fbf3_routers.write(str(endpoints) + ' ' + str(int(routers)) + '\n')

	'''

	print(">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>")


	'''

	for i in range(0,len(ks)):
		#DLN costs
		k = ks[i]
		
		[dln_final_cost,dln_final_power,routers,endpoints] = dln_cost_radix(k)

		if(dln_final_cost > 0):
			dln_k.write(str(endpoints) + ' ' + str(int(dln_final_cost)) + '\n')

		if(dln_final_power > 0):
			dln_power.write(str(endpoints) + ' ' + str(int(dln_final_power)) + '\n')

		if(routers > 0):
			dln_routers.write(str(endpoints) + ' ' + str(int(routers)) + '\n')

		'''

	print(">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>")
	print(">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>")
	print(">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>")

#now for SF and others
	qs = 			[5, 7, 8, 9, 11, 13, 16, 17, 19, 23, 25, 27, 29, 31, 32, 37, 41, 43]
	deltas = 	[1,-1, 0, 1, -1,  1,  0,  1, -1, -1,  1, -1,  1, -1,  0,  1,  1, -1]

	assert(len(qs) == len(deltas))

	for i in range(0,len(qs)):
		q = qs[i]
		delta = deltas[i]

		[k_r,p,k,N_r,N] = sf(q,delta)
		print("\n>>>>>>>>>>>>>>>>>>>>>>>> N: %d, k: %d" % (N,k))

		a = 2*q

		g_1 = int(N_r/(1.0*a))
		r_1 = int(a)
		e_1 = r_1*p

		[sf_cost,sf_power,routers] = sf_a_2q_cost(k,N,q,delta)

		sf_a_2q.write(str(N) + ' ' + str(int(sf_cost)) + '\n')
		sf_a_2q_power.write(str(N) + ' ' + str(int(sf_power)) + '\n')

		if(routers > 0):
			sf_a_2q_routers.write(str(N) + ' ' + str(int(routers)) + '\n')


		#print(">>>>>>> SF for q = %d, k = %d, N = %d, N_r = %d, k_r = %d, p = %d, a = %d" % (q, k, N, N_r, k_r, p, a))
		#print("\tpossible group conbinations: (%d groups, %d routers, %d endpoints); (%d groups, %d routers, %d endpoints)" % (g_1,r_1,e_1,g_2,r_2,e_2))

		

		#FBF costs

		[fbf3_final_cost,fbf3_final_power,routers,endpoints] = fbf3_cost_old(k,N)

		if(fbf3_final_cost > 0):
			fbf3_k.write(str(endpoints) + ' ' + str(int(fbf3_final_cost)) + '\n')

		if(fbf3_final_power > 0):
			fbf3_power.write(str(endpoints) + ' ' + str(int(fbf3_final_power)) + '\n')

		if(routers > 0):
			fbf3_routers.write(str(endpoints) + ' ' + str(int(routers)) + '\n')

		#DF costs
		
		

		[df_final_cost,df_final_power,routers,endpoints] = df_cost_relaxed(k,N)

		if(df_final_cost > 0):
			df_k_N.write(str(endpoints) + ' ' + str(int(df_final_cost)) + '\n')
		
		if(df_final_power > 0):
			df_power.write(str(endpoints) + ' ' + str(int(df_final_power)) + '\n')
	
		if(routers > 0):
			df_routers.write(str(endpoints) + ' ' + str(int(routers)) + '\n')

		

		#DLN costs
		
		[dln_final_cost,dln_final_power,routers,endpoints] = dln_cost(k,N,q)

		if(dln_final_cost > 0):
			dln_k.write(str(endpoints) + ' ' + str(int(dln_final_cost)) + '\n')

		if(dln_final_power > 0):
			dln_power.write(str(endpoints) + ' ' + str(int(dln_final_power)) + '\n')

		if(routers > 0):
			dln_routers.write(str(endpoints) + ' ' + str(int(routers)) + '\n')

	

		#T3D costs
		
		[t3d_final_cost,t3d_final_power,routers,endpoints] = t3d_cost_balanced(N)

		if(t3d_final_cost > 0):
			t3d.write(str(endpoints) + ' ' + str(int(t3d_final_cost)) + '\n')
		
		if(t3d_final_power > 0):
			t3d_power.write(str(endpoints) + ' ' + str(int(t3d_final_power)) + '\n')
	
		if(routers > 0):
			t3d_routers.write(str(endpoints) + ' ' + str(int(routers)) + '\n')

		
		#T5D costs
		
		[t5d_final_cost,t5d_final_power,routers,endpoints] = t5d_cost_balanced(N)

		if(t5d_final_cost > 0):
			t5d.write(str(endpoints) + ' ' + str(int(t5d_final_cost)) + '\n')

		if(t5d_final_power > 0):
			t5d_power.write(str(endpoints) + ' ' + str(int(t5d_final_power)) + '\n')

		if(routers > 0):
			t5d_routers.write(str(endpoints) + ' ' + str(int(routers)) + '\n')

	
		#HC costs
		
		[hc_final_cost,hc_final_power,routers,endpoints] = hc_cost(N,2*q)

		if(hc_final_cost > 0):
			hc.write(str(endpoints) + ' ' + str(int(hc_final_cost)) + '\n')

		if(hc_final_power > 0):
			hc_power.write(str(endpoints) + ' ' + str(int(hc_final_power)) + '\n')

		if(routers > 0):
			hc_routers.write(str(endpoints) + ' ' + str(int(routers)) + '\n')

	
		#LH-HC costs
		
		[lh_hc_final_cost,lh_hc_final_power,routers,endpoints] = lh_hc_cost(N, 2*q)

		if(lh_hc_final_cost > 0):
			lh_hc.write(str(endpoints) + ' ' + str(int(lh_hc_final_cost)) + '\n')

		if(lh_hc_final_power > 0):
			lh_hc_power.write(str(endpoints) + ' ' + str(int(lh_hc_final_power)) + '\n')

		if(routers > 0):
			lh_hc_routers.write(str(endpoints) + ' ' + str(int(routers)) + '\n')

		'''
	
		#LH-2 costs
			
		[lh2_final_cost,lh2_final_power,routers,endpoints] = lh2_cost(k,N)

		if(lh2_final_cost > 0):
			lh2.write(str(endpoints) + ' ' + str(int(lh2_final_cost)) + '\n')

		if(lh2_final_power > 0):
			lh2_power.write(str(endpoints) + ' ' + str(int(lh2_final_power)) + '\n')

		if(routers > 0):
			lh2_routers.write(str(endpoints) + ' ' + str(int(routers)) + '\n')

		'''


		'''
	
		#FT-3 costs
			
		[ft3_final_cost,ft3_final_power,routers,endpoints] = ft3_cost(k,N)

		if(ft3_final_cost > 0):
			ft3.write(str(endpoints) + ' ' + str(int(ft3_final_cost)) + '\n')

		if(ft3_final_power > 0):
			ft3_power.write(str(endpoints) + ' ' + str(int(ft3_final_power)) + '\n')

		if(routers > 0):
			ft3_routers.write(str(endpoints) + ' ' + str(int(routers)) + '\n')

		'''	




		# >>>>>>>>>>>>>>>>>>>>>>>>>>> check DF configurations

		'''
		df_costs = []

		for p in range(1,k):
			for a in range(2,int(N/k)):
				h = k+1-p-a
				if(h <= 0):
					continue

				df_g = int(math.ceil(N / (a*p)))
				df_N_r = df_g*a

				N_by_a = "YES"
				N_by_p = "YES"
				eq_1 = "YES"
				eq_2 = "YES"
				eq_3 = "YES"
				eq_4 = "YES"

				if(N % a != 0):
					N_by_a = "NO"

				if(N % p != 0):
					N_by_p = "NO"

				if(3*a + 2*p < 2*k + 2):
					eq_1 = "NO"

				if(a + 2*p < k + 1):
					eq_2 = "NO"

				if(N_r*p > a*p*(a*h + 1)):
					eq_3 = "NO"

				if(N_by_a == "YES" and N_by_p == "YES" and eq_1 == "YES" and eq_2 == "YES" and eq_3 == "YES" and h > 0 and (p >= 0.2*(a+h-1) and p <= 0.3*(a+h-1))):
				#if(eq_1 == "YES" and eq_2 == "YES" and eq_3 == "YES" and eq_4 == "YES" and h > 0):
					#print("\tDF with p = %d: N_by_a: %s, N_by_p: %s, eq_1: %s, eq_2: %s, eq_3: %s, eq_4: %s" % (p, N_by_a, N_by_p, eq_1, eq_2, eq_3, eq_4))
					#print("\tparams: N = %d, k = %d, g = %d, a = %d, h = %d, p = %d\n" % (N, k, g, a, h, p))

					cables_t = (df_g*(df_g-1))/2
					cables_p = (h*a*df_g)/2

					#print(">>>> DF: %d routers, %d groups; group size: %d" % (df_g*a, df_g, a))
					print(">>>> DF: %d routers, %d groups; group size: %d, endpoints (computed): %d, k (computed): %d, p: %d, h: %d" % (df_N_r, df_g, a, p*df_N_r, p+h+a-1, p, h))
					print("\tT: %d, P: %d\n" % (cables_t, cables_p))

					df_E_r = df_N_r*rt(k)

					#get the cost of electric cables inside groups

					df_E_i = df_g * (a*(a-1)/2) * el(1)

					#get the cost of global cables

					df_dims = get_decomposition(df_g)

					df_E_o = get_global_cables_cost_df(df_dims,1)
				
					df_final_cost = df_E_r + df_E_i + df_E_o
					
					print("\t E_r: %d, E_i: %d, E_o: %d,\t\tE_c: %d" % (int(df_E_r), int(df_E_i), int(df_E_o), int(df_final_cost)))

					df_costs.append(df_final_cost)

			if(len(df_costs) > 0):
				df_cost_min = min(df_costs)
				df_a_2q.write(str(N) + ' ' + str(int(df_cost_min)) + '\n')
		'''


		'''	# >>>>>>>>>>>>>>>>>>>>>>>>>>> check DF configurations

		df_costs = []

		for p in range(1,k):
			h = k+1-p-a
			if(h <= 0):
				continue
			a = 2*h
			df_g = int(math.ceil(N / (a*p)))

			N_by_a = "YES"
			N_by_p = "YES"
			eq_1 = "YES"
			eq_2 = "YES"
			eq_3 = "YES"
			eq_4 = "YES"

			if(N % a != 0):
				N_by_a = "NO"

			if(N % p != 0):
				N_by_p = "NO"

			if(3*a + 2*p < 2*k + 2):
				eq_1 = "NO"

			if(a + 2*p < k + 1):
				eq_2 = "NO"

			if(N < 2*p*df_g*h):
				eq_3 = "NO"

			if(N < a*df_g*h):
				eq_4 = "NO"

			#if(N_by_a == "YES" and N_by_p == "YES" and eq_1 == "YES" and eq_2 == "YES" and eq_3 == "YES" and eq_4 == "YES" and h > 0):
			if(eq_1 == "YES" and eq_2 == "YES" and eq_3 == "YES" and eq_4 == "YES" and h > 0):
				#print("\tDF with p = %d: N_by_a: %s, N_by_p: %s, eq_1: %s, eq_2: %s, eq_3: %s, eq_4: %s" % (p, N_by_a, N_by_p, eq_1, eq_2, eq_3, eq_4))
				#print("\tparams: N = %d, k = %d, g = %d, a = %d, h = %d, p = %d\n" % (N, k, g, a, h, p))

				cables_t = (df_g*(df_g-1))/2
				cables_p = (h*a*df_g)/2

				print(">>>> DF: %d routers, %d groups; group size: %d" % (df_g*a, df_g, a))

				#print("T: %d, P: %d\n" % (cables_t, cables_p))

				df_E_r = (a*df_g)*rt(k)

				#get the cost of electric cables inside groups

				df_E_i = df_g * (a*(a-1)/2) * el(1)

				#get the cost of global cables

				df_dims = get_decomposition(df_g)

				df_E_o = get_global_cables_cost_df(df_dims,1)
			
				df_final_cost = df_E_r + df_E_i + df_E_o
				
				print("\t E_r: %d, E_i: %d, E_o: %d,\t\tE_c: %d" % (int(df_E_r), int(df_E_i), int(df_E_o), int(df_final_cost)))

				df_costs.append(df_final_cost)

		if(len(df_costs) > 0):
			df_cost = min(df_costs)
			df_a_2q.write(str(N) + ' ' + str(int(df_cost)) + '\n') '''

		a = 2*q
		g_2 = int(N_r/(2*q))
		r_2 = int(2*q)
		e_2 = r_2*p

	sf_a_2q.close()

	df_full_p.close()
	df_k_N.close()

	fbf3_k.close()
	ft3_k.close()
	dln_k.close()

	fbf3_N.close()
	ft3_N.close()
	dln_N.close()

	t3d.close()
	t5d.close()
	hc.close()
	lh2.close()
	lh_hc.close()



	sf_a_2q_power.close()
	fbf3_power.close()
	df_power.close()
	t3d_power.close()
	t5d_power.close()
	dln_power.close()
	ft3_power.close()
	lh2_power.close()
	lh_hc_power.close()
	hc_power.close()

	sf_a_2q_routers.close()
	fbf3_routers.close()
	df_routers.close()
	t3d_routers.close()
	t5d_routers.close()
	dln_routers.close()
	ft3_routers.close()
	lh2_routers.close()
	lh_hc_routers.close()
	hc_routers.close()


sf_generate()
