import math

def nic_power():
	return 0

def router_power(k):
	return k*4*0.7

def el(x):
	#our prev
	#result = 120*(0.1409*x + 0.3643)

	#mellanox fdr10/qdr 40Gb, up to 5 meters
	#result = 40*(0.273*x + 1.041)

	#mellanox fdr10/qdr 40Gb, from 2 up to 7 meters
	result = 40*(0.4079*x + 0.5771)

	#mellanox qdr 56Gb
	#result = 56*(0.2042*x + 1.2341)

	#elpheus eth10Gb
	#result = 10*(0.8568*x + 2.4791)

	#FBF-model:
	#result = 120*(1.4*x + 2.16)
	return result

def op(x):
	#our
	#result = 120*(0.05429*x + 2.202)
	
	#mellanox fdr10 40Gb
	result = 40*(0.0919*x + 7.2745)
	
	#mellanox qdr 56Gb
	#result = 56*(0.1031*x + 6.0464)

	#elpheus eth10Gb
	#result = 10*(0.1768*x + 10.4211)

	#FBF-model
	#result = 120*(0.364*x + 9.7103)
	return result

def rt(k):
	#result = 150.7*k + 928.8
	#result = -959 + 349*k

	#used stuff
	#result = -323 + 340*k

	#fdr-10/qdr
	result = 350.4*k -892.3

	#Ethernet Mellanox
	#result = 225*k + 3353.7

	#result = 1052 + 232*k
	return result

def manh_dist(i,j,m,n):
	return abs(i - m) + abs(j - n)

def get_decomposition(g):
	dimensions = [0,0,0] #[x,y,z]
	edge = int(math.floor(math.sqrt(g)))
	rest = g - edge*edge
	dimensions[0] = edge
	dimensions[1] = edge

	if(rest < edge):
		dimensions[2] = rest
	elif(rest == edge):
		dimensions[0] += 1
	elif(rest > edge):
		dimensions[0] += 1
		dimensions[2] = rest - edge

	return dimensions
	
def get_global_cables_cost_df(dims, bunch):
	nr = 0
	X = dims[0]
	Y = dims[1]
	Z = dims[2]
	cost = 0
	for i in range(0,X):
		for j in range(0,Y):
			for m in range(0,X):
				for n in range(0,Y):
					dist = manh_dist(i,j,m,n)
					c_el = el(dist+2)
					c_op = op(dist+2)

					nr += bunch

					cost += min(c_el, c_op)*bunch

	cost /= 2
	nr /= 2

	for u in range(0,Z):
		for m in range(0,X):
			for n in range(0,Y):
				dist = manh_dist(m,n,u,-1)
				c_el = el(dist+2)
				c_op = op(dist+2)

				nr += bunch

				cost += min(c_el, c_op)*bunch

	remainder_nr = 0
	remainder_cost = 0
	for i in range(0,Z):
		for j in range(0,Z):
			dist = manh_dist(i,0,j,0)
			c_el = el(dist+2)
			c_op = op(dist+2)

			remainder_nr += bunch

			remainder_cost += min(c_el,c_op)*bunch

	remainder_nr /= 2
	remainder_cost /= 2
	cost += remainder_cost
	nr += remainder_nr

	return [cost,nr]


def get_global_cables_cost_sf_a_2q(dims, q):
	nr = 0
	bunch = 2*q
	X = dims[0]
	Y = dims[1]
	Z = dims[2]
	cost = 0
	for i in range(0,X):
		for j in range(0,Y):
			for m in range(0,X):
				for n in range(0,Y):
					dist = manh_dist(i,j,m,n)
					c_el = el(dist+2)
					c_op = op(dist+2)

					nr += bunch

					cost += min(c_el, c_op)*bunch

	nr /= 2
	cost /= 2

	for u in range(0,Z):
		for m in range(0,X):
			for n in range(0,Y):
				dist = manh_dist(m,n,u,-1)
				c_el = el(dist+2)
				c_op = op(dist+2)

				nr += bunch

				cost += min(c_el, c_op)*bunch

	remainder_nr = 0
	remainder_cost = 0
	for i in range(0,Z):
		for j in range(0,Z):
			dist = manh_dist(i,0,j,0)
			c_el = el(dist+2)
			c_op = op(dist+2)

			remainder_nr += bunch

			remainder_cost += min(c_el,c_op)*bunch

	remainder_nr /= 2
	remainder_cost /= 2
	cost += remainder_cost
	nr += remainder_nr

	return [cost,nr]









