from cost_model import *
from random import *
import math
import sys

def dln_cost_radix(k):
	k = int(k)

	p = int(k/4.0) #similar to DF
	a = 2*p
	h = p
	g = a*h+1
	k_r = k - p

	N = g*a*p
	N_r = g*a

	dims = get_decomposition(g)

	#get the cost of routers
	E_r = N_r*rt(k)

	#get the number of local/global cables:

	#N_l_c = (N_r * k_r * local_perc)/2.0*g
	#N_g_c = (N_r * k_r * global_perc)/2.0

	avg_local = 1
	avg_global = (1 + (dims[0] + dims[1] - 1)) / 2.0

	N_l_c = 0
	N_g_c = 0
	E_i = 0
	E_o = 0

	for router in range(0, N_r):
		h = randint(1, k_r)
		N_l_c += (k_r - h)
		N_g_c += h
		E_i += (k_r - h) * el(1)
		E_o += h * op(avg_global + 2)

	N_l_c /= 2
	N_g_c /= 2
	E_i /= 2
	E_o /= 2

	#get the cost of electric cables inside groups

	#E_i = N_l_c * el(1)

	#get the cost of global cables


	#E_o = N_g_c * op(dims[0]/2.0 + 2)

	final_cost = E_r+E_i+E_o
	final_power = N*nic_power() + N_r*router_power(k)

	N_el = N_l_c
	N_op = N_g_c
	E_l = E_i
	E_g = E_o

	if((N >= 8000 and N <= 12000) or (k >= 41 and k <= 46)):
		print(">>>>>>>>>>>> DLN (fixed k)")
		print("\tN: %d, N_r: %d, k: %d, k': %d, p: %d" % (N, N_r, k, k_r, p))
		print("\tN_el: %d, N_op: %d, N_l: %d, N_g: %d" % (N_el, N_op, N_l_c, N_g_c))
		print("\ta: %d, g: %d" % (a, g))
		print("\tC-per_endpoint: %d, P-per_endpoint: %f" % (int(final_cost/(1.0*N)), float(final_power/(1.0*N))))
		print("\tC_r: %d, C_el: %d, C_o: %d, C_c: %d" % (int(E_r), int(E_l), int(E_g), int(final_cost)))

	#print("\t >>>> DLN: N_r: %d, E_r: %d, E_i: %d, E_o: %d,\t\tE_c: %d" % (int(N_r), int(E_r), int(E_i), int(E_o), int(final_cost)))
	#print("\t E_r: %d, E_i: %d, E_o: %d,\t\tE_c: %d, E-per_endpoint: %d, P-per_endpoint: %f" % (int(E_r), int(N_l_c), int(N_g_c), int(final_cost),int(final_cost/(1.0*N)), float(final_power/(1.0*N))))

	#final_power = N_r*k*4*0.7

	return [final_cost,final_power,N_r,N]



def dln_cost(k,N,g):
	k = int(k)
	N = int(N)
	N_origin = N

	g = int(g)
	p = int((k+1)/4.0) #similar to DF
	k_r = k - p

	N_r = int(math.ceil(N/(1.0*p)))

	a = int(math.ceil(N_r/(1.0*g)))

	#local_perc = ((a+0.0)/N_r)
	#global_perc = ((N_r-a-0.0)/N_r)

	dims = get_decomposition(g)

	#get the cost of routers

	E_r = N_r*rt(k)

	#get the number of local/global cables:

	#N_l_c = (N_r * k_r * local_perc)/2.0*g
	#N_g_c = (N_r * k_r * global_perc)/2.0

	avg_local = 1
	avg_global = (1 + (dims[0] + dims[1] - 1)) / 2.0

	N_l_c = 0
	N_g_c = 0
	E_i = 0
	E_o = 0

	for router in range(0, N_r):
		h = randint(1, k_r)
		N_l_c += (k_r - h)
		N_g_c += h
		E_i += (k_r - h) * el(1)
		E_o += h * op(avg_global + 2)

	N_l_c /= 2
	N_g_c /= 2
	E_i /= 2
	E_o /= 2

	#get the cost of electric cables inside groups

	#E_i = N_l_c * el(1)

	#get the cost of global cables


	#E_o = N_g_c * op(dims[0]/2.0 + 2)

	final_cost = E_r+E_i+E_o
	final_power = N*nic_power() + N_r*router_power(k)

	N_el = N_l_c
	N_op = N_g_c
	E_l = E_i
	E_g = E_o
	
	print(">>>>>>>>>>>> DLN")
	print("\tN: %d, N_r: %d, k: %d, k': %d, p: %d" % (N, N_r, k, k_r, p))
	print("\tN_el: %d, N_op: %d, N_l: %d, N_g: %d" % (N_el, N_op, N_l_c, N_g_c))
	print("\tC-per_endpoint: %d, P-per_endpoint: %f" % (int(final_cost/(1.0*N)), float(final_power/(1.0*N))))
	print("\tC_r: %d, C_el: %d, C_o: %d, C_c: %d" % (int(E_r), int(E_l), int(E_g), int(final_cost)))

	#print("\t >>>> DLN: N_r: %d, E_r: %d, E_i: %d, E_o: %d,\t\tE_c: %d" % (int(N_r), int(E_r), int(E_i), int(E_o), int(final_cost)))
	#print("\t E_r: %d, E_i: %d, E_o: %d,\t\tE_c: %d, E-per_endpoint: %d, P-per_endpoint: %f" % (int(E_r), int(N_l_c), int(N_g_c), int(final_cost),int(final_cost/(1.0*N)), float(final_power/(1.0*N))))

	#final_power = N_r*k*4*0.7

	return [final_cost,final_power,N_r,N]

if(len(sys.argv) > 1):
	k = int(sys.argv[1])
	N = int(sys.argv[2])
	cost = df_cost(k,N)
	print 'DF cost (k = ' + str(k) + ', N = ' + str(N) + ') is: ' + str(int(cost)) + ' $\n'

	
	
	
