from cost_model import *
import math
import sys

def ft3_cost_radix(k):
	k = int(k)

	#k = int(math.ceil(math.pow(4*N,1/3.0)))

	N_r = (5*k*k)/4.0
	N = k*k*k/4.0

	E_r = N_r*rt(k)

	final_cost = 0

	#N_l_c = k*k*k/4.0
	#E_i = N_l_c*el(1)
	E_i = 0
	E_o = 0
	N_l_c = 0
	N_g_c = 0

	pods = k	
	N_in_pod = N / k
	k_r = k / 2.0
	p = k / 2.0

	dims = get_decomposition(pods)

	x = dims[0]
	y = dims[1]
	z = dims[2]

	if(y % 2 == 0):
		for i in range(0,y/2):
			length = i*2
			if(length < 6):
				E_i += x * 2*N_in_pod * el(2 + length)
				N_l_c += x * 2*N_in_pod
			else:
				E_o += x * 2*N_in_pod * op(2 + length)
				N_g_c += x * 2*N_in_pod
		length = (y/2)*2
		E_o += z * N_in_pod * op(2 + length)
		N_g_c += z * N_in_pod
	else:
		for i in range(0,int(y/2)):
			length = i*2
			if(length < 6):
				E_i += x * 2*N_in_pod * el(2 + length)
				N_l_c += x * 2*N_in_pod
			else:
				E_o += x * 2*N_in_pod * op(2 + length)
				N_g_c += x * 2*N_in_pod
		length = (y/2)*2
		E_o += x * 1*N_in_pod * el(2 + length)
		N_g_c += x * 1*N_in_pod
		E_o += z * N_in_pod * el(2 + length)
		N_g_c += z * N_in_pod

	#print("x: %d, y: %d, z: %d, Ngc: %d, Nlc: %d, comp: %d" % (x, y, z, N_g_c, N_l_c, k*k*k/4.0))
	assert(int(N_g_c+N_l_c) == int(k*k*k/4.0))

	N_c_c = k*k*k/2.0

	E_o += N_c_c * op(x/2)

	N_el = N_l_c
	N_op = N_g_c + N_c_c
	E_l = E_i
	E_g = E_o

	final_cost = E_r+E_l+E_o
	final_power = N*nic_power() + N_r*router_power(k)

	if((N >= 8000 and N <= 12000) or (k >= 41 and k <= 46)):
		print(">>>>>>>>>>>> FT-3 (fixed k, balanced)")
		print("\tN: %d, N_r: %d, k: %d, k': %d, p: %d" % (N, N_r, k, k_r, p))
		print("\tN_el: %d, N_op: %d, N_l: %d, N_g: %d" % (N_el, N_op, N_l_c, N_g_c))
		print("\tpods %d" % (pods))
		print("\tC-per_endpoint: %d, P-per_endpoint: %f" % (int(final_cost/(1.0*N)), float(final_power/(1.0*N))))
		print("\tC_r: %d, C_el: %d, C_o: %d, C_c: %d" % (int(E_r), int(E_l), int(E_g), int(final_cost)))

	#print("\t >>>> FT-3: N_r: %d, E_r: %d, E_i: %d, E_o: %d,\t\tE_c: %d" % (int(N_r), int(E_r), int(E_i), int(E_o), int(final_cost)))
	#print("\t E_r: %d, E_i: %d, E_o: %d,\t\tE_c: %d, E-per_endpoint: %d, P-per_endpoint: %f" % (int(E_r), int(N_l_c), int(N_g_c), int(final_cost),int(final_cost/(1.0*N)), float(final_power/(1.0*N))))

	return [final_cost,final_power,N_r,N]





def ft3_cost(k,N):
	k = int(k)
	N_origin = int(N)

	#k = int(math.ceil(math.pow(4*N,1/3.0)))

	N_r = (5*k*k)/4.0
	N = k*k*k/4.0

	E_r = N_r*rt(k)

	final_cost = 0

	#N_l_c = k*k*k/4.0
	#E_i = N_l_c*el(1)
	E_i = 0
	E_o = 0
	N_l_c = 0
	N_g_c = 0

	pods = k	
	N_in_pod = N / k
	k_r = k / 2.0
	p = k / 2.0

	dims = get_decomposition(pods)

	x = dims[0]
	y = dims[1]
	z = dims[2]

	if(y % 2 == 0):
		for i in range(0,y/2):
			length = i*2
			if(length < 6):
				E_i += x * 2*N_in_pod * el(2 + length)
				N_l_c += x * 2*N_in_pod
			else:
				E_o += x * 2*N_in_pod * op(2 + length)
				N_g_c += x * 2*N_in_pod
		length = (y/2)*2
		E_o += z * N_in_pod * op(2 + length)
		N_g_c += z * N_in_pod
	else:
		for i in range(0,int(y/2)):
			length = i*2
			if(length < 6):
				E_i += x * 2*N_in_pod * el(2 + length)
				N_l_c += x * 2*N_in_pod
			else:
				E_o += x * 2*N_in_pod * op(2 + length)
				N_g_c += x * 2*N_in_pod
		length = (y/2)*2
		E_o += x * 1*N_in_pod * el(2 + length)
		N_g_c += x * 1*N_in_pod
		E_o += z * N_in_pod * el(2 + length)
		N_g_c += z * N_in_pod

	print("x: %d, y: %d, z: %d, Ngc: %d, Nlc: %d, comp: %d" % (x, y, z, N_g_c, N_l_c, k*k*k/4.0))
	assert(int(N_g_c+N_l_c) == int(k*k*k/4.0))

	N_c_c = k*k*k/2.0

	E_o += N_c_c * op(x/2)

	N_el = N_l_c
	N_op = N_g_c + N_c_c
	E_l = E_i
	E_g = E_o

	final_cost = E_r+E_l+E_o
	final_power = N*nic_power() + N_r*router_power(k)

	print(">>>>>>>>>>>> FT-3")
	print("\tN: %d, N_r: %d, k: %d, k': %d, p: %d" % (N, N_r, k, k_r, p))
	print("\tN_el: %d, N_op: %d, N_l: %d, N_g: %d" % (N_el, N_op, N_l_c, N_g_c))
	print("\tpods %d" % (pods))
	print("\tC-per_endpoint: %d, P-per_endpoint: %f" % (int(final_cost/(1.0*N)), float(final_power/(1.0*N))))
	print("\tC_r: %d, C_el: %d, C_o: %d, C_c: %d" % (int(E_r), int(E_l), int(E_g), int(final_cost)))

	#print("\t >>>> FT-3: N_r: %d, E_r: %d, E_i: %d, E_o: %d,\t\tE_c: %d" % (int(N_r), int(E_r), int(E_i), int(E_o), int(final_cost)))
	#print("\t E_r: %d, E_i: %d, E_o: %d,\t\tE_c: %d, E-per_endpoint: %d, P-per_endpoint: %f" % (int(E_r), int(N_l_c), int(N_g_c), int(final_cost),int(final_cost/(1.0*N)), float(final_power/(1.0*N))))

	return [final_cost,final_power,N_r,N]

if(len(sys.argv) > 1):
	k = int(sys.argv[1])
	N = int(sys.argv[2])
	cost = df_cost(k,N)
	print 'DF cost (k = ' + str(k) + ', N = ' + str(N) + ') is: ' + str(int(cost)) + ' $\n'

	
	
	
