from cost_model import *
import math
import sys

def sf(q,delta):
	N_r = 2*q*q
	k_r = (3*q + delta)/2.0
	p = int(math.floor(k_r/2.0)+1)
	#p = int(math.ceil(k_r/2.0)+1)
	k = p+k_r
	N = p*N_r
	return [k_r,p,k,N_r,N]

def sf_a_2q_cost(k,N,q,delta):
	k = int(k)
	N = int(N)

	[k_r,p,k,N_r,N] = sf(q,delta)

	a = 2*q
	g = int(N_r / (1.0*a))
	
	#get the cost of routers

	E_r = N_r*rt(k)

	#get the cost of electric cables inside groups
	#!!!!!!!!!!!!!!!!!!!! for now the upper bound

	##E_i = g * (a*(a-1)/2) * el(1) / 2
	#N_l_c = (N_r*k_r)/2.0 - (N_r*q)/2.0 + q*q
	#E_i = ((N_r*k_r)/2.0 - (N_r*q)/2.0 + q*q)*el(1)

	N_l_c = int(0.5 * (a*(a-1)/2)) *g
	E_i = N_l_c*el(1)

	#get the cost of global cables

	dims = get_decomposition(g)
	#print 'Decomposing ' + str(g) + ' groups. Dimensions: X: ' + str(dims[0]) + ', Y: ' + str(dims[1]) + ', Z: ' + str(dims[2]) + '\n'

	[E_o,N_g_c] = get_global_cables_cost_sf_a_2q(dims,q)

	final_cost = E_r+E_i+E_o

	final_power = N*nic_power() + N_r*router_power(k)

	N_el = N_l_c
	N_op = N_g_c
	E_l = E_i
	E_g = E_o

	if((N >= 8000 and N <= 12000) or (k >= 41 and k <= 46)):
		print(">>>>>>>>>>>> SF")
		print("\tN: %d, N_r: %d, k: %d, k': %d, p: %d" % (N, N_r, k, k_r, p))
		print("\tN_el: %d, N_op: %d, N_l: %d, N_g: %d" % (N_el, N_op, N_l_c, N_g_c))
		print("\ta: %d, g: %d" % (a, g))
		print("\tC-per_endpoint: %d, P-per_endpoint: %f" % (int(final_cost/(1.0*N)), float(final_power/(1.0*N))))
		print("\tC_r: %d, C_el: %d, C_o: %d, C_c: %d" % (int(E_r), int(E_l), int(E_g), int(final_cost)))

	#print(">>>> SF: %d routers, %d groups; group size: %d, cables: %d, global: %d, power: %d" % (N_r, g, a, N_l_c+N_g_c,N_g_c,int(final_power)))
	##print("\t E_r: %d, E_i: %d, E_o: %d,\t\tE_c: %d" % (int(E_r), int(E_i), int(E_o), int(final_cost)))
	#print("\t E_r: %d, E_i: %d, E_o: %d,\t\tE_c: %d, E-per_endpoint: %d, P-per_endpoint: %f" % (int(E_r), int(N_l_c), int(N_g_c), int(final_cost),int(final_cost/(1.0*N)), float(final_power/(1.0*N))))


	#final_power = N_r*k*4*0.7

	return [final_cost,final_power,N_r]

if(len(sys.argv) > 1):
	k = int(sys.argv[1])
	N = int(sys.argv[2])

	
	
	
