from cost_model import *
import math
import sys

#to be finished!!!!
def t3d_cost_all_fixed(k,N,den):	#den - endpoints in one rack
	k = int(k)
	N = int(N)

	k_r = 3*2
	p = k - k_r

	N_r = int(math.ceil(N/(1.0*p)))

	r_r = int(math.floor(den/(1.0*p)))	#max routers per rack

	N_rc = int(math.ceil(N_r/(1.0*a)))	#nr of racks

	e = int(math.floor(math.pow(N,1/3.0)))

	rest = N - e*e*e

	g = e*e
	k = 1 + 2*3

	#print(">>>> DF: %d routers, %d groups; group size: %d, endpoints (computed): %d, k (computed): %d, p: %d" % (N_r, g, a, p*N_r, 4*p-1, p))

	#get the cost of routers

	E_r = N_r*rt(k)

	#get the cost of electric cables inside groups

	E_i = 0

	#get the cost of global cables

	E_o = (3*2*e*(e-1)*e + 2*e*6)*el(1)

	final_cost = E_r+E_i+E_o

	print("\t E_r: %d, E_i: %d, E_o: %d,\t\tE_c: %d" % (int(E_r), int(E_i), int(E_o), int(final_cost)))

	final_power = N*10 + N_r*k*4*0.7
	#final_power = N_r*k*4*0.7

	return [final_cost,final_power]

def t3d_cost_fixed_radix(k,N):
	k = int(k)
	N = int(N)

	k_r = 2*3
	p = 1
	k = k_r + p

	N_r = int(math.ceil(N/(1.0*p)))

	#get the cost of routers
	E_r = N_r*rt(k)
	
	e = int(math.floor(math.pow(N_r,1/3.0)))
	#g = e*e

	N_r_rest = N_r - e*e*e
	nr_of_add_layers = int(math.floor(N_r_rest/(1.0*e*e)))
	#TODO include the remaining few routers

	#e_rest = int(math.floor(math.pow(N_r_rest,1/2.0)))
	#g_rest = e_rest*e_rest

	#get the cost of electric cables

	N_l_c = (e+nr_of_add_layers)*(e-1)*e + (e+nr_of_add_layers-1)*e*e + (e+nr_of_add_layers)*(e-1)*e
	E_el = N_l_c * el(1)

	#get the cost of global cables

	N_g_c = (e*e) + (e+nr_of_add_layers)*e + (e+nr_of_add_layers)*e
	E_o = (e*e)*op(2 + e+nr_of_add_layers) + (e+nr_of_add_layers)*e*op(2+e) + (e+nr_of_add_layers)*e*op(2+e)

	final_cost = E_r+E_el+E_o

	final_power = N*nic_power() + N_r*k*4*0.7

	print(">>>> T3D: N_r: %d, N_l_c: %d, N_g_c: %d, N_r_rest: %d, nr_add_layers: %d, endpoints (computed): %d, k: %d, p: %d" % (N_r, N_l_c, N_g_c, N_r_rest, nr_of_add_layers, N_r*p, k_r+p, p))


	return [final_cost,final_power]



def t3d_cost_balanced(N):
	N = int(N)
	N_origin = N
	p = 1

	e = int(math.floor(math.pow(N,1/3.0)))

	N_rest = N - e*e*e
	nr_of_add_2d_layers = int(math.floor(N_rest/(1.0*e*e)))
	N_2d_rest = N_rest - nr_of_add_2d_layers * e*e
	assert(N_2d_rest >= 0 and N_2d_rest < e*e)

	dimX = e
	dimY = e
	dimZ = e + nr_of_add_2d_layers

	N = dimX * dimY * dimZ 
	assert(N_origin == N + N_2d_rest)

	N_r = N
	k = p + 2*3
	k_r = k - p

	#get the cost of routers
	E_r = N_r*rt(k)

	#get the number of short cables

	N_l_c = 0
	N_l_c += 3*(e-1)*e*e #

	N_l_c += nr_of_add_2d_layers*(e*e + (e-1)*e + e*(e-1)) 

	#N_l_c = (e+nr_of_add_layers)*(e-1)*e + (e+nr_of_add_layers-1)*e*e + (e+nr_of_add_layers)*(e-1)*e // OLD way of doing this

	#get the cost of short cables
	E_l = N_l_c * el(1)

	#get the number of global (also electric, we assume folding)
	N_g_c = 2 * (e-1)*(e+nr_of_add_2d_layers) + e*e  #(e*e) + (e+nr_of_add_2d_layers)*e + (e+nr_of_add_2d_layers)*e
	#E_g = (e*e)*el(e+nr_of_add_2d_layers) + (e+nr_of_add_2d_layers)*e*el(e) + (e+nr_of_add_2d_layers)*e*el(e)
	E_g = N_g_c * el(3)  #(e*e)*el(1) + (e+nr_of_add_2d_layers)*e*el(1) + (e+nr_of_add_2d_layers)*e*el(1)

	N_el = N_l_c+N_g_c
	N_op = 0

	final_cost = E_r+E_l+E_g
	final_power = N*nic_power() + N_r*router_power(k)

	if(N >= 8000 and N <= 12000):
		print(">>>>>>>>>>>> T3D")
		print("\tN: %d, N_r: %d, k: %d, k': %d, p: %d" % (N, N_r, k, k_r, p))
		print("\tN_el: %d, N_op: %d, N_l: %d, N_g: %d" % (N_el, N_op, N_l_c, N_g_c))
		print("\tdimX: %d, dimY: %d, dimZ: %d" % (dimX, dimY, dimZ))
		print("\tN_rest: %d, nr_add_layers: %d, N_2d_rest: %d" % (N_rest, nr_of_add_2d_layers, N_2d_rest))
		print("\tC-per_endpoint: %d, P-per_endpoint: %f" % (int(final_cost/(1.0*N)), float(final_power/(1.0*N))))
		print("\tC_r: %d, C_el: %d, C_o: %d, C_c: %d" % (int(E_r), int(E_l+E_g), int(0), int(final_cost)))

	#print(">>>> T3D: N_r: %d, N_l_c: %d, N_g_c: %d, N_el: %d, N_r_rest: %d, nr_add_layers: %d, endpoints (computed): %d, k: %d, p: %d" % (N_r, N_l_c, N_g_c, N_g_c+N_l_c, N_r_rest, nr_of_add_2d_layers, N_r*p, k_r+p, p))
	#print("\t E_r: %d, E_el: %d, E_o: %d,\t\tE_c: %d" % (int(E_r), int(E_l+E_g), int(0), int(final_cost)))

	return [final_cost,final_power,N_r,N]

if(len(sys.argv) > 1):
	k = int(sys.argv[1])
	N = int(sys.argv[2])

	
	
	
