import re, string, sys, Queue

limit = 0 # limit number of source vertices, 0 for no limit!

def SSSP(graph, start, end):
  pred = {}
  q = Queue.Queue()
  q.put(start)
  while(not q.empty()):
    n = q.get()
    #print n, "(", start, end, ")"
    done = 0
    for neigh in graph[n]:
      q.put(neigh)
      #print ">>", neigh, n
      if(not pred.has_key(neigh)): pred[neigh] = n
      if(neigh == end): 
        done = 1
        break
    if(done): break

  n=end
  path=list()
  path.append(end)
  while(n != start):
    #print n, start
    n = pred[n]
    path.insert(0,n)
  del path[0] # remove first element!
  return path

if len(sys.argv) != 2:
  sys.exit("usage: "+sys.argv[0]+" <adjacency list>");

f = open(sys.argv[1])
graph = {}

firstline = 1
edges = 0
vertex = 1
# read input graph
for line in f:
  if firstline == 1: 
    firstline = 0 # skip first line
    continue
  s= string.split(line, " ");
  graph[vertex] = list()
  for i in range(0,len(s)-1):
    #print vertex, " ", s[i] 
    graph[vertex].append(int(s[i]))
    edges=edges+1 # keep edge count
  vertex=vertex+1
  #print "====", len(s)

print "vertices: ", len(graph)
print "edges: ", edges

longestpath = 0
pathsum = 0
#l = {};
#for u in range(1,len(graph)+1):
#  l[u] = {}
#  for v in range(1,len(graph)+1):
#    #print type(v), type(v), u, v
#    l[u][v] = 0

if limit == 0:
  limit = len(graph)

for start in range(1,limit+1):
  if(start % 10 == 0): print "...", start,"/", len(graph)
  for end in range(1,limit+1):
    path = SSSP(graph, start, end)
    #print start, end, path
    if(len(path) > longestpath): longestpath = len(path)
    pathsum = pathsum+len(path)
#    u = start
#    for v in path:
#      print ">>", u,v
#      if(u != v): l[u][v] = l[u][v] + 1
#      u=v

#loadsum = 0
#for u in range(1,len(graph)+1):
#  for v in range(1,len(graph)+1):
#    if u != v:
#      print u,v,l[u][v]
#      loadsum = loadsum + l[u][v]

print "longest path: ", longestpath
print "average path length: ", float(pathsum)/((limit-1)*limit)
print "average cable load: ", float(pathsum)/edges

