import re, string, sys, Queue, copy, random

limit = 0 # limit number of source vertices, 0 for no limit!

# check if graph is connected!
def connected(graph, vertices):
  num = 0
  q = Queue.Queue()
  if(len(graph[1]) == 0): return vertices-1
  q.put(graph[1][0])
  visited = {}
  while(not q.empty()):
    n = q.get()
    done = 0
    for neigh in graph[n]:
      if(not visited.has_key(neigh)): 
        visited[neigh] = 1
        q.put(neigh)
        num = num + 1

  return vertices-num


if len(sys.argv) != 4:
  sys.exit("usage: "+sys.argv[0]+" <adjacency list> <percent failures> <iters>");

f = open(sys.argv[1])
removeperc = int(sys.argv[2]) # remove x% of the cables
iterations = int(sys.argv[3])


graph = {}

firstline = 1
edges = 0
vertex = 1
# read input graph
for line in f:
  if firstline == 1: 
    firstline = 0 # skip first line
    continue
  s= string.split(line, " ");
  graph[vertex] = list()
  for i in range(0,len(s)-1):
    #print vertex, " ", s[i] 
    graph[vertex].append(int(s[i]))
    edges=edges+1 # keep edge count
  vertex=vertex+1
  #print "====", len(s)

print "vertices: ", len(graph)
print "edges: ", edges


if limit == 0:
  limit = len(graph)

removenum = edges * removeperc/100/2

disc = 0
conn = 0
 
print "removing", removenum, "random edges of", edges/2

for sample in range(0, iterations):
  faultygraph = copy.deepcopy(graph)
  faultyedges = edges
  # remove removenum edges randomly
  random.seed()
  for i in range(0,removenum):
    removeedge = random.randint(1, faultyedges-1)
    edgeindex = 0
    nodeindex = 1
    # find edge to remove
    while(edgeindex < removeedge):
      edgeindex = edgeindex+len(faultygraph[nodeindex])
      nodeindex = nodeindex + 1
    nodeindex = nodeindex - 1
    edgeindex = edgeindex-len(faultygraph[nodeindex])
    pos = removeedge-edgeindex
    #print edgeindex, removeedge, pos
    # the grpah is undirected but stored as adjacency list, thus, we
    # also need to remove two edges, a->b and b->a
    # here is the backward one
    faultygraph[faultygraph[nodeindex][pos-1]].remove(nodeindex);
    # now remove the forward edge
    del faultygraph[nodeindex][pos-1]
    faultyedges = faultyedges - 2
  
  # check if graph is connected
  missing = connected(faultygraph, len(faultygraph)) 
  if(missing > 0): 
    disc += 1
  else:
    conn += 1

#f_name = "disconnected_" + sys.argv[1] + "_" + sys.argv[2] + "_" + sys.argv[3]

#file = open(f_name, 'w')

#file.write("====== total iterations: " + str(iterations))
#file.write("disconnected: " + str(disc))

print "====== total iterations: " + str(iterations)
print "connected: " + str(conn)
print "disconnected: " + str(disc)
print "connected: " + str(conn)

#file.close()


