import re, string, sys, Queue, copy, random

limit = 0 # limit number of source vertices, 0 for no limit!


def SSSP(graph, start, end):
  pred = {}
  q = Queue.Queue()
  q.put(start)
  pred[start]=-1
  #print "====="
  while(not q.empty()):
    n = q.get()
    #print n, "(start: ", start, "end: ", end, ")", graph[n]
    done = 0
    for neigh in graph[n]:
      q.put(neigh)
      if(not pred.has_key(neigh)): 
        pred[neigh] = n
        #print neigh, ">->", n
      #else: print ">>>>>", pred[neigh]
      if(neigh == end):
        done = 1
        break
    if(done): break

  n=end
  path=list()
  path.append(end)
  while(n != start):
    #print "<<<", n, start
    n = pred[n]
    path.insert(0,n)
  del path[0] # remove first element!
  return path

# check if graph is connected!
def connected(graph, vertices):
  num = 0
  q = Queue.Queue()
  if(len(graph[1]) == 0): return vertices-1
  q.put(graph[1][0])
  visited = {}
  while(not q.empty()):
    n = q.get()
    done = 0
    for neigh in graph[n]:
      if(not visited.has_key(neigh)): 
        visited[neigh] = 1
        q.put(neigh)
        num = num + 1

  return vertices-num


if len(sys.argv) != 4:
  sys.exit("usage: "+sys.argv[0]+" <adjacency list> <percent failures> <iters>");

f = open(sys.argv[1])
removeperc = int(sys.argv[2]) # remove x% of the cables
iterations = int(sys.argv[3])


graph = {}

firstline = 1
edges = 0
vertex = 1
# read input graph
for line in f:
  if firstline == 1: 
    firstline = 0 # skip first line
    continue
  s= string.split(line, " ");
  graph[vertex] = list()
  for i in range(0,len(s)-1):
    #print vertex, " ", s[i] 
    graph[vertex].append(int(s[i]))
    edges=edges+1 # keep edge count
  vertex=vertex+1
  #print "====", len(s)

print "vertices: ", len(graph)
print "edges: ", edges


if limit == 0:
  limit = len(graph)

removenum = edges * removeperc/100/2

alongest = {}
apathsum = {}

for sample in range(0, iterations):
  faultygraph = copy.deepcopy(graph)
  faultyedges = edges
  # remove removenum edges randomly
  random.seed()
  print "removing", removenum, "random edges of", edges/2
  for i in range(0,removenum):
    removeedge = random.randint(1, faultyedges-1)
    edgeindex = 0
    nodeindex = 1
    # find edge to remove
    while(edgeindex < removeedge):
      edgeindex = edgeindex+len(faultygraph[nodeindex])
      nodeindex = nodeindex + 1
    nodeindex = nodeindex - 1
    edgeindex = edgeindex-len(faultygraph[nodeindex])
    pos = removeedge-edgeindex
    #print edgeindex, removeedge, pos
    # the grpah is undirected but stored as adjacency list, thus, we
    # also need to remove two edges, a->b and b->a
    # here is the backward one
    faultygraph[faultygraph[nodeindex][pos-1]].remove(nodeindex);
    # now remove the forward edge
    del faultygraph[nodeindex][pos-1]
    faultyedges = faultyedges - 2
  
  # check if graph is connected
  missing = connected(faultygraph, len(faultygraph)) 
  if(missing > 0): 
    print "disconnected!!!", missing
    continue

  longestpath = 0
  pathsum = 0
  for start in range(1,limit+1):
    if(start % 10 == 0): print "...", start,"/", len(graph)
    for end in range(1,limit+1):
      path = SSSP(faultygraph, start, end)
      #print start, end, path
      if(len(path) > longestpath): 
        longestpath = len(path)
        #print start, end, path
      pathsum = pathsum+len(path)

  print "diameter: ", longestpath
  alongest[len(alongest)] = longestpath
  print "average path length: ", float(pathsum)/((limit-1)*limit)
  print "average cable load: ", float(pathsum)/faultyedges
  apathsum[len(apathsum)] = float(pathsum)

longestpath = 0
pathsum = 0
for sample in range(0, len(alongest)):
  longestpath = longestpath + alongest[sample]
  pathsum = pathsum + apathsum[sample]

print "====== totals ======", len(alongest)
if(len(alongest) > 0):
  print "overall", removeperc, "diameter: ", float(longestpath)/len(alongest)
  print "overall", removeperc, "average path length: ", float(pathsum)/len(alongest)/((limit-1)*limit)
  print "overall", removeperc, "average cable load: ", float(pathsum)/len(alongest)/(edges-2*removenum)


